# 📝⚙️ `lua-paged-markdown-3`

_A library and command-line program to render [Paged Markdown 3](https://codeberg.org/leso-kn/paged-markdown-3) documents in Lua._

## Modules

This repository holds the source-code of multiple modules all around the editing and rendering of the Paged Markdown 3 document-format for scientific writing. You may have landed here coming from one of them:

* [PDF Renderer (cli)](#pdf-renderer-cli)
* [pmd3 (module)](#pmd3-module)
* [Neovim Plugin](#neovim-plugin)

## PDF Renderer (cli)

The `pmd-pdf` command-line program renders Paged Markdown 3 documents to pdf.

### Installation

Alpine Linux:

```bash
> apk add paged-markdown-3-pdf
```

via luarocks (all platforms):

```bash
> luarocks install paged-markdown-3-pdf
```

### Usage

Once installed the program can be invoked to render Paged Markdown 3 documents to pdf in the following basic scheme:

```bash
> pmd-pdf <input.md> [output.pdf]
```

A complete list of supported options is available via `pmd-pdf --help`.

## pmd3 (module)

This is the underlying Lua library that provides an API to render Paged Markdown 3 documents via code.

### Installation

via luarocks:

```bash
> luarocks install paged-markdown-3
```

## API

### `pmd3.render(source, filename)`

Renders the given Paged Markdown 3 source to HTML

#### Parameters

* `source` – Input paged markdown source (string)
* `filename` – Path to the source file on disk for resolving relative auxiliary files such as `design.css` (string)

**Returns: (1)** HTML markup of the rendered Paged Markdown 3 document  
**Returns: (2)** Table containing key-value pairs of the markdown YAML metadata (or nil if metadata is not present)

## Neovim Plugin

This Lua library is the foundation for [`pmd3.nvim`](https://codeberg.org/leso-kn/pmd3.nvim), a Neovim plugin for editing Paged Markdown 3 documents.

## License

lua-paged-markdown-3 is licensed under the MIT License.

---

Created by Lesosoftware in 2025
